import 'dart:convert';

import 'package:farm_tpf/custom_model/Other.dart';
import 'package:farm_tpf/data/api/app_exception.dart';
import 'package:farm_tpf/data/repository/repository.dart';
import 'package:farm_tpf/models/index.dart';
import 'package:farm_tpf/presentation/custom_widgets/app_bar_widget.dart';
import 'package:farm_tpf/presentation/custom_widgets/bloc/media_helper_bloc.dart';
import 'package:farm_tpf/presentation/custom_widgets/button_widget.dart';
import 'package:farm_tpf/presentation/custom_widgets/widget_field_time_picker.dart';
import 'package:farm_tpf/presentation/custom_widgets/widget_loading.dart';
import 'package:farm_tpf/presentation/custom_widgets/widget_media_picker.dart';
import 'package:farm_tpf/presentation/custom_widgets/widget_text_field_description.dart';
import 'package:farm_tpf/presentation/custom_widgets/widget_utils.dart';
import 'package:farm_tpf/presentation/screens/actions/bloc/action_detail_bloc.dart';
import 'package:farm_tpf/presentation/screens/actions/other/bloc_get_action_type.dart';
import 'package:farm_tpf/presentation/screens/actions/state_management_helper/change_file_controller.dart';
import 'package:farm_tpf/utils/const_common.dart';
import 'package:farm_tpf/utils/const_string.dart';
import 'package:farm_tpf/utils/pref.dart';
import 'package:farm_tpf/utils/validators.dart';
import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:get/get.dart';
import 'package:keyboard_dismisser/keyboard_dismisser.dart';
import 'package:farm_tpf/utils/formatter.dart';

import '../util_action.dart';

class EditActionOtherScreen extends StatefulWidget {
  final int cropId;
  final bool isEdit;
  final int? activityId;
  EditActionOtherScreen({
    required this.cropId,
    this.isEdit = false,
    this.activityId,
  });
  @override
  _EditActionOtherScreenState createState() => _EditActionOtherScreenState();
}

class _EditActionOtherScreenState extends State<EditActionOtherScreen> {
  final GlobalKey<ScaffoldState> _scaffoldKey = GlobalKey<ScaffoldState>();
  final _repository = Repository();
  GlobalKey<FormState> _formKey = GlobalKey();
  bool _autoValidate = false;
  var pref = LocalPref();
  Other _other = Other();
  final _descriptionController = TextEditingController();
  final _executeByController = TextEditingController();

  List<ActionType> _actionTypes = <ActionType>[];
  ActionType _actionType = ActionType();
  DateTime executeTime = DateTime.now();
  List<String> filePaths = <String>[];
  var changeFileController = Get.put(ChangeFileController());

  Future<Null> getSharedPrefs() async {
    var currentFullName = await pref.getString(DATA_CONST.CURRENT_FULL_NAME);
    _executeByController.text = currentFullName ?? "";
  }

  @override
  void initState() {
    super.initState();
    getSharedPrefs();
    changeFileController.initValue();
    _other.cropId = widget.cropId;

    if (!widget.isEdit) {
      getActionTypeBloc.getActionTypes((data) {
        _actionTypes = data;
      }, (err) {});
    }
  }

  _validateInputs() async {
    if (_formKey.currentState!.validate()) {
      _formKey.currentState!.save();
      LoadingDialog.showLoadingDialog(context);
      filePaths = Get.find<ChangeFileController>().newFiles;
      try {
        _other.mediaDel = Get.find<ChangeFileController>().deleteFiles;
        var activityOther = jsonEncode(_other.toJson()).toString();
        //ADD NEW
        if (_other.activityId == null) {
          _repository.createAction((value) {
            LoadingDialog.hideLoadingDialog(context);
            Get.back(result: value);
            Utils.showSnackBarSuccess(message: label_add_success);
          }, (error) {
            LoadingDialog.hideLoadingDialog(context);
            Utils.showSnackBarError(message: AppException.handleError(error));
          },
              apiAddAction: ConstCommon.apiAddOther,
              paramActivity: ConstCommon.paramsActionOther,
              activityAction: activityOther,
              filePaths: filePaths);
        } else {
          //UPDATE
          _repository.updateAction((value) {
            LoadingDialog.hideLoadingDialog(context);
            Get.back(result: value);
            Utils.showSnackBarSuccess(message: label_update_success);
          }, (error) {
            LoadingDialog.hideLoadingDialog(context);
            Utils.showSnackBarError(message: AppException.handleError(error));
          },
              apiUpdateAction: ConstCommon.apiUpdateOther,
              paramActivity: ConstCommon.paramsActionOther,
              activityAction: activityOther,
              filePaths: filePaths);
        }
      } catch (e) {
        LoadingDialog.hideLoadingDialog(context);
        print(e.toString());
      }
    } else {
      _autoValidate = true;
      Utils.showSnackBarWarning(message: label_validate_input_required);
    }
  }

  Widget _btnExecuteTimePicker() {
    return WidgetFieldDateTimePicker(
        initDateTime: executeTime,
        onUpdateDateTime: (selectedDate) {
          _other.executeDate = selectedDate.convertLocalDateTimeToStringUtcDateTime();
        });
  }

  List<DropdownMenuItem<ActionType>> _buildDropMenu(List<ActionType> actions) {
    return actions
        .map((action) => DropdownMenuItem<ActionType>(
              child: Text(action.description.toString()),
              value: action,
            ))
        .toList();
  }

  Widget _dropdownAcionTypes() {
    return StreamBuilder(
      stream: getActionTypeBloc.actions,
      builder: (context, AsyncSnapshot<dynamic> snapshot) {
        if (snapshot.hasData) {
          return DropdownButtonFormField<ActionType>(
              value: _actionType,
              hint: const Text("Hoạt động *"),
              onChanged: (ActionType? newValue) {
                setState(() {
                  _actionType = newValue ?? ActionType();
                  _other.activityTypeName = newValue?.name ?? '';
                });
              },
              validator: (value) => value == null ? label_validate_input_empty : null,
              isExpanded: true,
              items: _buildDropMenu(_actionTypes));
        } else if (snapshot.hasError) {
          return Container();
        } else {
          return const Center(
            child: CircularProgressIndicator(),
          );
        }
      },
    );
  }

  Widget _descriptionField() {
    return TextFieldDescriptionWidget(
      controller: _descriptionController,
      onSaved: (newValue) {
        _other.description = newValue;
      },
    );
  }

  Widget _executeByField() {
    return TextFormField(
      keyboardType: TextInputType.text,
      decoration: const InputDecoration(labelText: "Người thực hiện"),
      enabled: false,
      controller: _executeByController,
      onSaved: (newValue) {},
    );
  }

  @override
  Widget build(BuildContext context) => KeyboardDismisser(
          gestures: [
            GestureType.onTap,
            GestureType.onPanUpdateDownDirection,
          ],
          child: Scaffold(
              backgroundColor: Colors.white,
              key: _scaffoldKey,
              appBar: AppBarWidget(
                isBack: true,
                action: InkWell(
                  child: const Text(
                    'Huỷ',
                    style: TextStyle(color: Colors.red, fontWeight: FontWeight.normal),
                  ),
                  onTap: () {
                    if (Get.isSnackbarOpen) Get.back();
                    Get.back();
                  },
                ),
              ),
              body: KeyboardDismisser(
                  child: MultiBlocProvider(
                providers: [
                  BlocProvider<ActionDetailBloc>(
                    create: (context) => ActionDetailBloc(repository: Repository())
                      ..add(
                        FetchData(
                          isNeedFetchData: widget.isEdit,
                          apiActivity: ConstCommon.apiDetailOther,
                          activityId: widget.activityId ?? -1,
                        ),
                      ),
                  ),
                  BlocProvider<MediaHelperBloc>(
                    create: (context) => MediaHelperBloc()..add(ChangeListMedia(items: [])),
                  )
                ],
                child: Form(
                    key: _formKey,
                    // autovalidate: _autoValidate,
                    child: SafeArea(
                      child: SingleChildScrollView(
                        child: BlocConsumer<ActionDetailBloc, ActionDetailState>(
                          listener: (context, state) async {
                            if (state is ActionDetailFailure) {
                              LoadingDialog.hideLoadingDialog(context);
                            } else if (state is ActionDetailSuccess) {
                              LoadingDialog.hideLoadingDialog(context);
                              _other = Other.fromJson(state.item);
                              _other.activityId = widget.activityId ?? -1;
                              _descriptionController.text = _other.description ?? "";
                              _executeByController.text = _other.createdByName ?? '';

                              //select harvest
                              getActionTypeBloc.getActionTypes((data) {
                                _actionTypes = data;
                                for (var item in _actionTypes) {
                                  if (item.name == _other.activityTypeName) {
                                    _actionType = item;
                                    break;
                                  }
                                }
                              }, (err) {});
                              Get.find<ChangeDateTimePicker>()
                                  .change(_other.executeDate?.convertStringServerDateTimeToLocalDateTime() ?? DateTime.now());

                              //Show media
                              if (Validators.stringNotNullOrEmpty(_other.media ?? '')) {
                                BlocProvider.of<MediaHelperBloc>(context)
                                    .add(ChangeListMedia(items: UtilAction.convertFilePathToMedia(_other.media ?? '')));
                              }
                            } else if (state is ActionDetailInitial) {
                            } else if (state is ActionDetailLoading) {
                              LoadingDialog.showLoadingDialog(context);
                            }
                          },
                          builder: (context, state) {
                            return Column(
                              children: [
                                Padding(
                                  padding: const EdgeInsets.all(8.0),
                                  child: Column(
                                    crossAxisAlignment: CrossAxisAlignment.start,
                                    children: <Widget>[
                                      const Text(
                                        plot_action_other,
                                        style: TextStyle(fontWeight: FontWeight.w500, fontSize: 22),
                                      ),
                                      const SizedBox(
                                        height: 8.0,
                                      ),
                                      Container(
                                        width: double.infinity,
                                        child: const Text(
                                          "Ngày thực hiện *",
                                          style: TextStyle(color: Colors.black54, fontSize: 13.0),
                                        ),
                                      ),
                                      _btnExecuteTimePicker(),
                                      const SizedBox(
                                        height: 8.0,
                                      ),
                                      _dropdownAcionTypes(),
                                      const SizedBox(
                                        height: 8.0,
                                      ),
                                      _descriptionField(),
                                      const SizedBox(
                                        height: 8.0,
                                      ),
                                      _executeByField(),
                                      const SizedBox(
                                        height: 8.0,
                                      ),
                                    ],
                                  ),
                                ),
                                Container(
                                  width: double.infinity,
                                  height: 16,
                                  color: Colors.grey[200],
                                ),
                                BlocBuilder<MediaHelperBloc, MediaHelperState>(builder: (context, state) {
                                  if (state is MediaHelperSuccess) {
                                    return WidgetMediaPicker(
                                        currentItems: state.items,
                                        onChangeFiles: (newPathFiles, deletePathFiles) async {
                                          Get.find<ChangeFileController>().change(newPathFiles, deletePathFiles);
                                        });
                                  } else {
                                    return const Center(child: CircularProgressIndicator());
                                  }
                                }),
                                Padding(
                                  padding: const EdgeInsets.all(8.0),
                                  child: ButtonWidget(
                                      title: 'CẬP NHẬT',
                                      onPressed: () {
                                        var currentFocus = FocusScope.of(context);
                                        if (!currentFocus.hasPrimaryFocus) {
                                          currentFocus.unfocus();
                                        }
                                        _validateInputs();
                                      }),
                                ),
                              ],
                            );
                          },
                        ),
                      ),
                    )),
              ))));
  @override
  void dispose() {
    _descriptionController.dispose();
    _executeByController.dispose();
    super.dispose();
  }
}
